package com.alicloud.openservices.tablestore.model.internal;

import com.alicloud.openservices.tablestore.core.utils.Preconditions;
import com.alicloud.openservices.tablestore.model.*;

import java.util.ArrayList;
import java.util.List;

/**
 * 内部接口
 */
public class CreateTableRequestEx extends CreateTableRequest {

    private List<PartitionRange> partitionRangeList;

    public CreateTableRequestEx(TableMeta tableMeta, TableOptions tableOptions) {
        super(tableMeta, tableOptions);
    }

    public CreateTableRequestEx(
            TableMeta tableMeta,
            TableOptions tableOptions,
            ReservedThroughput reservedThroughput)
    {
        this(tableMeta, tableOptions, reservedThroughput, new ArrayList<PartitionRange>());
    }

    public CreateTableRequestEx(
            TableMeta tableMeta,
            TableOptions tableOptions,
            ReservedThroughput reservedThroughput,
            List<PartitionRange> partitionRanges)
    {
        super(tableMeta, tableOptions);
        setReservedThroughput(reservedThroughput);
        setPartitionRangeList(partitionRanges);
    }

    public List<PartitionRange> getPartitionRangeList() {
        return partitionRangeList;
    }

    public void setPartitionRangeList(List<PartitionRange> partitionRangeList) {
        Preconditions.checkNotNull(partitionRangeList);
        this.partitionRangeList = partitionRangeList;
    }

}
